package net.keil.openFileView;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

/**
 * The main plugin class to be used in the desktop.
 * 
 * @author Torsten Keil
 * @since 1.0.0
 */
public class OpenFileViewPlugin extends AbstractUIPlugin {
	
	public final static String PLUGIN_ID = "net.keil.openFileView";
	public boolean using31 = false;

	//The shared instance.
	private static OpenFileViewPlugin plugin;
	
	/**
	 * The constructor.
	 */
	public OpenFileViewPlugin() {
		plugin = this;
		try {
			using31 = IEditorReference.class.getMethod("getEditorInput",null) != null;
		} catch (Exception ex){}
	}

	/**
	 * This method is called upon plug-in activation
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
	}

	/**
	 * This method is called when the plug-in is stopped
	 */
	public void stop(BundleContext context) throws Exception {
		super.stop(context);
		plugin = null;
	}
	
	/**
	 * Returns the shared instance.
	 */
	public static OpenFileViewPlugin getDefault() {
		return plugin;
	}

	/**
	 * Returns an image descriptor for the image file at the given
	 * plug-in relative path.
	 *
	 * @param path the path
	 * @return the image descriptor
	 */
	public static ImageDescriptor getImageDescriptor(String path) {
		return AbstractUIPlugin.imageDescriptorFromPlugin("OpenFileView", path);
	}
	
	public IFile getFileForReference(IEditorReference ref){
		if ( ref == null )
			return null;
		try {
			IFile file = null;
			IEditorInput input = null;
			IEditorPart part = ref.getEditor(true);
			if ( part != null ) {
				input = part.getEditorInput();
			}
			if ( input != null ) {
				file = (IFile)input.getAdapter(IFile.class);
			}
			return file;
		} catch (Exception ex){
			return null;
		}
	}
}
