package net.keil.openFileView.preferences;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;

import net.keil.openFileView.OpenFileViewPlugin;

/**
 * Class used to initialize default preference values.
 * 
 * @author Torsten Keil
 * @since 1.4.0
 */
public class PreferenceInitializer extends AbstractPreferenceInitializer {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer#initializeDefaultPreferences()
	 */
	public void initializeDefaultPreferences() {
		IPreferenceStore store = OpenFileViewPlugin.getDefault().getPreferenceStore();
		store.setDefault(PreferenceConstants.P_USE_31_LOOK, PreferenceConstants.O_30_LOOK);
		store.setDefault(PreferenceConstants.P_SHOW_CLOSE_COLUMN, true);
		store.setDefault(PreferenceConstants.P_SHOW_FILE_ICONS, true);
		store.setDefault(PreferenceConstants.P_SHOW_PROJECT_ICONS, true);
	}

}
