/**
 * 
 */
package net.keil.openFileView.views;

import net.keil.openFileView.OpenFileViewPlugin;
import net.keil.openFileView.preferences.PreferenceConstants;
import net.keil.openFileView.util.OpenFileItem;

import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.viewers.ITableFontProvider;
import org.eclipse.swt.graphics.Font;
import org.eclipse.ui.IEditorPart;

/**
 * 
 * @author Torsten Keil
 * @since 1.4.0
 */
class ViewLabelFontProvider extends ViewLabelProvider implements ITableFontProvider{
	/**
	 * 
	 */
	private final OpenFileView view;

	/**
	 * @param view
	 */
	ViewLabelFontProvider(OpenFileView view) {
		super(view);
		this.view = view;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.ITableFontProvider#getFont(java.lang.Object, int)
	 */
	public Font getFont(Object element, int columnIndex) {
		IPreferenceStore store = OpenFileViewPlugin.getDefault().getPreferenceStore();
		String look = store.getString(PreferenceConstants.P_USE_31_LOOK);
		if (PreferenceConstants.O_30_LOOK.equals(look)) {
			return this.view.defaultFont;
		}
		if (element instanceof OpenFileItem) {
			OpenFileItem item = (OpenFileItem) element;
			if (this.view.activeEditorRef == null) { // not initialized
				IEditorPart activeEditorPart = this.view.getSite().getPage().getActiveEditor();
				IEditorPart editorPart = item.getEditorPart();
				if (editorPart != null && editorPart.equals(activeEditorPart)) {
					return this.view.boldFont;
				} else {
					return this.view.defaultFont;
				}
			} else {
				if (item.getEditorRef().equals(this.view.activeEditorRef)) {
					return this.view.boldFont;
				} else {
					return this.view.defaultFont;
				}
			}
		} else if (element instanceof Object[]) {
			OpenFileItem item = (OpenFileItem) ((Object[])element)[view.getFileColumnIndex()];
			if (this.view.activeEditorRef == null) { // not initialized
				IEditorPart activeEditorPart = this.view.getSite().getPage().getActiveEditor();
				IEditorPart editorPart = item.getEditorPart();
				if (editorPart != null && editorPart.equals(activeEditorPart)) {
					return this.view.boldFont;
				} else {
					return this.view.defaultFont;
				}
			} else {
				if (item.getEditorRef().equals(this.view.activeEditorRef)) {
					return this.view.boldFont;
				} else {
					return this.view.defaultFont;
				}
			} 
		} else {
			return this.view.defaultFont;
		}
	}
}